[Cqoi2014]危桥 (两遍网络流)

题目链接

  1 #include <bits/stdc++.h>
  2 using namespace std;
  3 typedef long long ll;
  4 inline int read()
  5 {
  6     int x=0,f=1;char ch=getchar();
  7     while(ch<‘0‘||ch>‘9‘){if(ch==‘-‘)f=-1;ch=getchar();}
  8     while(ch>=‘0‘&&ch<=‘9‘){x=x*10+ch-‘0‘;ch=getchar();}
  9     return x*f;
 10 }
 11
 12 /********************************************************************/
 13
 14 #define inf 0xffffff
 15 #define T 2001
 16 const int maxn = 2e6+7;
 17 const int Maxn = 2e3+5;
 18 int a, b;
 19 int ans1, ans2;
 20 int head[Maxn], q[Maxn], dis[Maxn], from[Maxn];
 21 bool vis[Maxn];
 22
 23 struct node
 24 {
 25     int to, from, Next;
 26     int v, c;
 27 }e[maxn];
 28 int cnt = 1;
 29
 30 int gcd(int x, int y){
 31     if(y == 0) return x;
 32     else return gcd(y, x%y);
 33 }
 34
 35 void add_edge(int u, int v, int w, int c){
 36     e[++cnt].to = v; e[cnt].from = u; e[cnt].Next = head[u]; head[u] = cnt;
 37     e[cnt].v = w; e[cnt].c = c;
 38 }
 39
 40 void insert(int u, int v, int w, int c){
 41     add_edge(u, v, w, c);
 42     add_edge(v, u, 0, -c);
 43 }
 44
 45 //是否满足条件
 46 bool check(int x, int y){
 47     if(x < y) swap(x, y);
 48     int t = int(sqrt(x*x-y*y));
 49     return (gcd(y, t) == 1 && x*x-y*y == t*t);
 50 }
 51
 52 bool spfa(){
 53     for(int i = 0;i <= T;i++){
 54         dis[i] = -inf;
 55     }
 56     int t = 0, w = 1;
 57     dis[0] = 0; q[0] = 0; vis[0] = 1;
 58     while(t != w){
 59         int now = q[t]; t++;
 60         if(t == T) t = 0;
 61         for(int i = head[now];i;i = e[i].Next){
 62             if(e[i].v && e[i].c+dis[now] > dis[e[i].to]){
 63                 dis[e[i].to] = e[i].c + dis[now];
 64                 from[e[i].to] = i;
 65                 if(!vis[e[i].to]){
 66                     vis[e[i].to] = 1;
 67                     q[w++] = e[i].to;
 68                     if(w == T) w = 0;
 69                 }
 70             }
 71         }
 72         vis[now] = 0;
 73     }
 74     if(dis[T] == -inf) return false;
 75     return true;
 76 }
 77
 78 void dfs(){
 79     int x = inf;
 80     for(int i = from[T];i;i = from[e[i].from]){
 81         x = min(e[i].v, x);
 82     }
 83     for(int i = from[T];i;i = from[e[i].from]){
 84         ans2 += x*e[i].c;
 85         e[i].v -= x;
 86         e[i^1].v += x;
 87     }
 88 }
 89
 90 int main(){
 91     a = read(); b = read();
 92     for(int i = a;i <= b;i++){
 93         for(int j = a;j <= b;j++){
 94             if(check(i, j) && i != j){
 95                 insert(i, j+1000, 1, i+j);
 96             }
 97         }
 98     }
 99     for(int i = a;i <= b;i++){
100         insert(0, i, 1, 0);
101         insert(i+1000, T, 1, 0);
102     }
103     while(spfa()) dfs();
104     for(int i = 2;i <= cnt;i += 2){
105         if()
106     }
107     return 0;
108 }

原文地址:https://www.cnblogs.com/ouyang_wsgwz/p/9827406.html

时间: 2024-11-23 11:14:03

[Cqoi2014]危桥 (两遍网络流)的相关文章

Luogu3163 [CQOI2014]危桥 ---- 网络流 及 一个细节的解释

Luogu3163 [CQOI2014]危桥 题意 有$n$个点和$m$条边,有些边可以无限次数的走,有些边这辈子只能走两次,给定两个起点和终点$a_1 --> a_2$(起点 --> 终点)和$b_1 --> b_2$(起点 --> 终点),询问是否可以让$a_1 --> a_2$往返$a_n$次,让$b_1 --> b_2$往返$b_n$次 题解 思路 思路还是比较好想的,就是原图连双向边,然后炒鸡源汇连$a_n*2$和$b_n*2$判断满流是否为$(a_n+b_n

bzoj千题计划137:bzoj [CQOI2014]危桥

http://www.lydsy.com/JudgeOnline/problem.php?id=3504 往返n遍,即单向2*n遍 危桥流量为2,普通桥流量为inf 原图跑一遍最大流 交换b1,b2再跑一遍最大流 如果两次的结果都等于(an+bn)*2 则可以 证明参见http://www.cnblogs.com/chenyushuo/p/5139556.html #include<queue> #include<cstdio> #include<cstring> #i

3504: [Cqoi2014]危桥

3504: [Cqoi2014]危桥 链接 分析: 首先往返的可以转化为全是“往”,那么只要将容量除以2即可. 然后S向a1连边容量为an(除以2之前为2*an),S向a2连边容量为an,b1,b2向T连边容量为bn.原图上的边,建双向边保存. 这样会存在从a1流向b2的流量,当然也有b1流向a2的流量,考虑如何判断这种情况. 将b1,b2交换,然后重新跑一遍,判断是否满流即可. 第一遍最大流的时候,假设a1->b2流了x的流量,那么有 a1->a2:an-x, a1->b2:x, b1

P3163 [CQOI2014]危桥

传送门 我是看不出这玩意儿和网络流有什么关系-- 我们把图中的所有边都当成无向边加入图中,容量为\(inf\) 危桥的容量为\(2\) 从源点到\(a1,b1\)连边容量为\(an*2\),\(a2,b2\)到汇点连边容量\(bn*2\),相当于一次把两边都走完 然后跑一遍看看是否满流即可 然而这样会有一个问题,就是最终求得的最大流是\(a1\)流向\(b2\)或\(a2\)流向\(b1\) 于是再从源点向\(a1\)和\(b2\)连边,\(a2\)和\(b1\)向汇点连边,再跑一遍看看是否满流

bzoj3504: [Cqoi2014]危桥

题意:给出一个图,有的边可以无限走,有的只能走两次(从一头到另一头为一次),给定两个起点以及对应的终点以及对应要走几个来回,求判断是否能完成. 先来一个NAIVE的建图:直接限制边建为容量1,无限制为INF,按照原图连,然后跑最大流就可以了. 可惜这样还不够,因为有可能有一部分流量不是对应的起点流过来的,即两条路有流量交换,这样就不一定可以满足题意了. 解决方法是:再跑一遍网络流,但是建图要改变一下,即将a路线的起点终点调换一下(当然b也可以),再接着跑,如果仍然满足则是真的有解. 证明看了网上

【BZOJ 3504】[Cqoi2014]危桥

Description Alice和Bob居住在一个由N座岛屿组成的国家,岛屿被编号为0到N-1.某些岛屿之间有桥相连,桥上的道路是双 向的,但一次只能供一人通行.其中一些桥由于年久失修成为危桥,最多只能通行两次.Alice希望在岛屿al和a2之间往返an次(从al到a2再从a2 到al算一次往返).同时,Bob希望在岛屿bl和b2之间往返bn次.这个过程中,所有危桥最多通行两次,其余的桥可以无限次通行.请问Alice和 Bob能完成他们的愿望吗? Input 本题有多组测试数据. 每组数据第一

bzoj3504: [Cqoi2014]危桥 网络流

一种网络流建图的思路吧,改天最好整理一波网络流建图思路 1 #include <bits/stdc++.h> 2 using namespace std; 3 int n,h,t,a1,a2,an,b1,b2,bn,flow,now;char ch; 4 int dis[52],l[52],d[52][52];char c[52][52]; 5 char getch() 6 { 7 for(ch=getchar();ch!='O' && ch!='N' && c

bzoj3504: [Cqoi2014]危桥--最大流

题目大意:给张无向图,有两个人a,b分别从各自的起点走向各自的终点,走A,B个来回,图里有些边只能走两次,求问是否能满足a,b的需求 按照题目给的表建图 S连a1,b1 a2,b2连T 跑最大流看是否满流 为了防止a1跑到b2的情况 第二遍 S连a1,b2 a2,b1连T 若还是满流说明没问题 1 #include<stdio.h> 2 #include<string.h> 3 #include<algorithm> 4 #include<queue> 5

bzoj 3504: [Cqoi2014]危桥

1 #include<cstdio> 2 #include<iostream> 3 #include<cstring> 4 #define M 100009 5 #define inf 2139062143 6 using namespace std; 7 int n,a1,a2,an,b1,b2,bn,tot,cnt=1,T,ans,head[M],d[M],q[2*M],next[10*M],u[10*M],v[10*M]; 8 char ch[60][60]; 9